diff --git a/openbsc/src/gprs/gb_proxy.c b/openbsc/src/gprs/gb_proxy.c
index 3c41529..4799344 100644
--- a/openbsc/src/gprs/gb_proxy.c
+++ b/openbsc/src/gprs/gb_proxy.c
@@ -45,8 +45,8 @@
 
 enum gbprox_global_ctr {
 	GBPROX_GLOB_CTR_INV_BVCI,
-	GBPROX_GLOB_CTR_INV_LAC,
-	GBPROX_GLOB_CTR_INV_RAC,
+	GBPROX_GLOB_CTR_INV_LAI,
+	GBPROX_GLOB_CTR_INV_RAI,
 	GBPROX_GLOB_CTR_INV_NSEI,
 	GBPROX_GLOB_CTR_PROTO_ERR_BSS,
 	GBPROX_GLOB_CTR_PROTO_ERR_SGSN,
@@ -59,8 +59,8 @@ enum gbprox_global_ctr {
 
 static const struct rate_ctr_desc global_ctr_description[] = {
 	{ "inv-bvci",	    "Invalid BVC Identifier          " },
-	{ "inv-lac",	    "Invalid Location Area Code      " },
-	{ "inv-rac",	    "Invalid Routing Area Code       " },
+	{ "inv-lai",	    "Invalid Location Area Identifier" },
+	{ "inv-rai",	    "Invalid Routing Area Identifier " },
 	{ "inv-nsei",	    "No BVC established for NSEI     " },
 	{ "proto-err.bss",  "BSSGP protocol error      (BSS )" },
 	{ "proto-err.sgsn", "BSSGP protocol error      (SGSN)" },
@@ -154,8 +154,8 @@ static struct gbprox_peer *peer_by_nsei(uint16_t nsei)
 	return NULL;
 }
 
-/* look-up a peer by its Routeing Area Code (RAC) */
-static struct gbprox_peer *peer_by_rac(const uint8_t *ra)
+/* look-up a peer by its Routeing Area Identification (RAI) */
+static struct gbprox_peer *peer_by_rai(const uint8_t *ra)
 {
 	struct gbprox_peer *peer;
 	llist_for_each_entry(peer, &gbprox_bts_peers, list) {
@@ -165,8 +165,8 @@ static struct gbprox_peer *peer_by_rac(const uint8_t *ra)
 	return NULL;
 }
 
-/* look-up a peer by its Location Area Code (LAC) */
-static struct gbprox_peer *peer_by_lac(const uint8_t *la)
+/* look-up a peer by its Location Area Identification (LAI) */
+static struct gbprox_peer *peer_by_lai(const uint8_t *la)
 {
 	struct gbprox_peer *peer;
 	llist_for_each_entry(peer, &gbprox_bts_peers, list) {
@@ -389,11 +389,11 @@ static int gbprox_rx_sig_from_bss(struct msgb *msg, uint16_t nsei,
 	switch (pdu_type) {
 	case BSSGP_PDUT_SUSPEND:
 	case BSSGP_PDUT_RESUME:
-		/* We implement RAC snooping during SUSPEND/RESUME, since
-		 * it establishes a relationsip between BVCI/peer and the
-		 * routeing area code.  The snooped information is then
-		 * used for routing the {SUSPEND,RESUME}_[N]ACK back to
-		 * the correct BSSGP */
+		/* We implement RAI snooping during SUSPEND/RESUME, since it
+		 * establishes a relationsip between BVCI/peer and the routeing
+		 * area identification.  The snooped information is then used
+		 * for routing the {SUSPEND,RESUME}_[N]ACK back to the correct
+		 * BSSGP */
 		if (!TLVP_PRESENT(&tp, BSSGP_IE_ROUTEING_AREA))
 			goto err_mand_ie;
 		from_peer = peer_by_nsei(nsei);
@@ -403,7 +403,7 @@ static int gbprox_rx_sig_from_bss(struct msgb *msg, uint16_t nsei,
 			sizeof(from_peer->ra));
 		gsm48_parse_ra(&raid, from_peer->ra);
 		LOGP(DGPRS, LOGL_INFO, "NSEI=%u BSSGP SUSPEND/RESUME "
-			"RAC snooping: RAC %u-%u-%u-%u behind BVCI=%u\n",
+			"RAI snooping: RAI %u-%u-%u-%u behind BVCI=%u\n",
 			nsei, raid.mcc, raid.mnc, raid.lac,
 			raid.rac , from_peer->bvci);
 		/* FIXME: This only supports one BSS per RA */
@@ -485,15 +485,15 @@ static int gbprox_rx_paging(struct msgb *msg, struct tlv_parsed *tp,
 			bvci);
 		errctr = GBPROX_GLOB_CTR_OTHER_ERR;
 	} else if (TLVP_PRESENT(tp, BSSGP_IE_ROUTEING_AREA)) {
-		peer = peer_by_rac(TLVP_VAL(tp, BSSGP_IE_ROUTEING_AREA));
-		LOGPC(DGPRS, LOGL_INFO, "routing by RAC to peer BVCI=%u\n",
+		peer = peer_by_rai(TLVP_VAL(tp, BSSGP_IE_ROUTEING_AREA));
+		LOGPC(DGPRS, LOGL_INFO, "routing by RAI to peer BVCI=%u\n",
 			peer ? peer->bvci : -1);
-		errctr = GBPROX_GLOB_CTR_INV_RAC;
+		errctr = GBPROX_GLOB_CTR_INV_RAI;
 	} else if (TLVP_PRESENT(tp, BSSGP_IE_LOCATION_AREA)) {
-		peer = peer_by_lac(TLVP_VAL(tp, BSSGP_IE_LOCATION_AREA));
-		LOGPC(DGPRS, LOGL_INFO, "routing by LAC to peer BVCI=%u\n",
+		peer = peer_by_lai(TLVP_VAL(tp, BSSGP_IE_LOCATION_AREA));
+		LOGPC(DGPRS, LOGL_INFO, "routing by LAI to peer BVCI=%u\n",
 			peer ? peer->bvci : -1);
-		errctr = GBPROX_GLOB_CTR_INV_LAC;
+		errctr = GBPROX_GLOB_CTR_INV_LAI;
 	} else
 		LOGPC(DGPRS, LOGL_INFO, "\n");
 
@@ -590,7 +590,7 @@ static int gbprox_rx_sig_from_sgsn(struct msgb *msg, uint32_t nsei,
 		break;
 	case BSSGP_PDUT_PAGING_PS:
 	case BSSGP_PDUT_PAGING_CS:
-		/* process the paging request (LAC/RAC lookup) */
+		/* process the paging request (LAI/RAI lookup) */
 		rc = gbprox_rx_paging(msg, &tp, nsei, ns_bvci);
 		break;
 	case BSSGP_PDUT_STATUS:
@@ -616,10 +616,10 @@ static int gbprox_rx_sig_from_sgsn(struct msgb *msg, uint32_t nsei,
 	case BSSGP_PDUT_SUSPEND_NACK:
 	case BSSGP_PDUT_RESUME_ACK:
 	case BSSGP_PDUT_RESUME_NACK:
-		/* RAC IE is mandatory */
+		/* RAI IE is mandatory */
 		if (!TLVP_PRESENT(&tp, BSSGP_IE_ROUTEING_AREA))
 			goto err_mand_ie;
-		peer = peer_by_rac(TLVP_VAL(&tp, BSSGP_IE_ROUTEING_AREA));
+		peer = peer_by_rai(TLVP_VAL(&tp, BSSGP_IE_ROUTEING_AREA));
 		if (!peer)
 			goto err_no_peer;
 		rc = gbprox_relay2peer(msg, peer, ns_bvci);
@@ -666,9 +666,9 @@ err_mand_ie:
 		     ctr[GBPROX_GLOB_CTR_PROTO_ERR_SGSN]);
 	return bssgp_tx_status(BSSGP_CAUSE_MISSING_MAND_IE, NULL, msg);
 err_no_peer:
-	LOGP(DGPRS, LOGL_ERROR, "NSEI=%u(SGSN) cannot find peer based on RAC\n",
+	LOGP(DGPRS, LOGL_ERROR, "NSEI=%u(SGSN) cannot find peer based on RAI\n",
 		nsei);
-	rate_ctr_inc(&get_global_ctrg()-> ctr[GBPROX_GLOB_CTR_INV_RAC]);
+	rate_ctr_inc(&get_global_ctrg()-> ctr[GBPROX_GLOB_CTR_INV_RAI]);
 	return bssgp_tx_status(BSSGP_CAUSE_UNKNOWN_BVCI, NULL, msg);
 }
 
@@ -853,7 +853,7 @@ int gbprox_dump_peers(FILE *stream, int indent, int verbose)
 		gsm48_parse_ra(&raid, peer->ra);
 
 		rc = fprintf(stream, "%*s  NSEI %u, BVCI %u, %sblocked, "
-			     "RAC %u-%u-%u-%u\n",
+			     "RAI %u-%u-%u-%u\n",
 			     indent, "",
 			     peer->nsei, peer->bvci,
 			     peer->blocked ? "" : "not ",
@@ -921,7 +921,7 @@ static void gbprox_vty_print_peer(struct vty *vty, struct gbprox_peer *peer)
 	gsm48_parse_ra(&raid, peer->ra);
 
 	vty_out(vty, "NSEI %5u, PTP-BVCI %5u, "
-		"RAC %u-%u-%u-%u",
+		"RAI %u-%u-%u-%u",
 		peer->nsei, peer->bvci,
 		raid.mcc, raid.mnc, raid.lac, raid.rac);
 	if (peer->blocked)
diff --git a/openbsc/tests/gbproxy/gbproxy_test.ok b/openbsc/tests/gbproxy/gbproxy_test.ok
index e677ec0..3b25922 100644
--- a/openbsc/tests/gbproxy/gbproxy_test.ok
+++ b/openbsc/tests/gbproxy/gbproxy_test.ok
@@ -101,7 +101,7 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 PROCESSING BVC_RESET_ACK from 0x05060708:32000
 00 00 00 00 23 04 82 10 02 
 
@@ -179,8 +179,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 PROCESSING BVC_RESET_ACK from 0x05060708:32000
 00 00 00 00 23 04 82 20 02 
 
@@ -242,8 +242,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Move BSS 2 to former BSS 1 port ---
 
 Setup NS-VC: remote 0x01020304:1111, NSVCI 0x2001(8193), NSEI 0x2000(8192)
@@ -291,8 +291,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Move BSS 1 to current BSS 2 port ---
 
 Setup NS-VC: remote 0x01020304:1111, NSVCI 0x2001(8193), NSEI 0x2000(8192)
@@ -340,8 +340,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Move BSS 2 to new port ---
 
 Setup NS-VC: remote 0x01020304:4444, NSVCI 0x2001(8193), NSEI 0x2000(8192)
@@ -389,8 +389,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Move BSS 2 to former BSS 1 port ---
 
 Setup NS-VC: remote 0x01020304:3333, NSVCI 0x2001(8193), NSEI 0x2000(8192)
@@ -441,8 +441,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Move BSS 1 to original BSS 1 port ---
 
 Setup NS-VC: remote 0x01020304:1111, NSVCI 0x1001(4097), NSEI 0x1000(4096)
@@ -491,8 +491,8 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Reset BSS 1 with a new BVCI ---
 
 Setup BSSGP: remote 0x01020304:1111, BVCI 0x1012(4114)
@@ -519,9 +519,9 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 4096, BVCI 4114, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 4114, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 PROCESSING BVC_RESET_ACK from 0x05060708:32000
 00 00 00 00 23 04 82 10 12 
 
@@ -562,9 +562,9 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 4096, BVCI 4114, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 4114, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 PROCESSING BVC_RESET_ACK from 0x05060708:32000
 00 00 00 00 23 04 82 10 02 
 
@@ -605,9 +605,9 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 4096, BVCI 4114, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 4114, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 PROCESSING BVC_RESET_ACK from 0x05060708:32000
 00 00 00 00 23 04 82 10 02 
 
@@ -744,10 +744,10 @@ Current NS-VCIs:
          NS-VC Block count         : 1
 
 Peers:
-  NSEI 4096, BVCI 4114, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 4114, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 Gbproxy global:
 PROCESSING BVC_RESET_ACK from 0x05060708:32000
@@ -932,7 +932,7 @@ MESSAGE to BSS at 0x01020304:1111, msg length 9
 result (BVC_RESET_ACK) = 9
 
 Peers:
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Setup BVCI 2 ---
 
 Setup BSSGP: remote 0x01020304:1111, BVCI 0x2002(8194)
@@ -966,8 +966,8 @@ MESSAGE to BSS at 0x01020304:1111, msg length 9
 result (BVC_RESET_ACK) = 9
 
 Peers:
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 4098, not blocked, RAI 112-332-16464-96
 --- Send message from BSS 1 to SGSN and back, BVCI 1 ---
 
 PROCESSING UNITDATA from 0x01020304:1111
@@ -1107,8 +1107,8 @@ MESSAGE to BSS at 0x01020304:1111, msg length 9
 result (BVC_RESET_ACK) = 9
 
 Peers:
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 --- Setup BVCI 3 ---
 
@@ -1143,9 +1143,9 @@ MESSAGE to BSS at 0x01020304:1111, msg length 9
 result (BVC_RESET_ACK) = 9
 
 Peers:
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 --- Send message from BSS 1 to SGSN and back, BVCI 1 ---
 
@@ -1194,10 +1194,10 @@ MESSAGE to SGSN at 0x05060708:32000, msg length 4
 result (UNITDATA) = 4
 
 Peers:
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 PROCESSING UNITDATA from 0x05060708:32000
 00 00 20 02 
@@ -1211,11 +1211,11 @@ NS UNITDATA MESSAGE to BSS, BVCI 0x2002, msg length 0
 result (UNITDATA) = -22
 
 Peers:
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
     NS Transmission error           : 1
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 --- Send message from BSS 1 to SGSN and back, BVCI 3 ---
 
@@ -1330,11 +1330,11 @@ MESSAGE to BSS at 0x01020304:1111, msg length 9
 result (BVC_RESET_ACK) = 9
 
 Peers:
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
     NS Transmission error           : 1
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 --- Setup BVCI 4 ---
 
@@ -1369,12 +1369,12 @@ MESSAGE to BSS at 0x01020304:1111, msg length 9
 result (BVC_RESET_ACK) = 9
 
 Peers:
-  NSEI 8192, BVCI 16386, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 16386, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
     NS Transmission error           : 1
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 --- Send message from BSS 1 to SGSN and back, BVCI 1 ---
 
@@ -1423,12 +1423,12 @@ MESSAGE to SGSN at 0x05060708:32000, msg length 4
 result (UNITDATA) = 4
 
 Peers:
-  NSEI 8192, BVCI 16386, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 16386, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 2
     NS Transmission error           : 1
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 PROCESSING UNITDATA from 0x05060708:32000
 00 00 20 02 
@@ -1442,12 +1442,12 @@ NS UNITDATA MESSAGE to BSS, BVCI 0x2002, msg length 0
 result (UNITDATA) = -22
 
 Peers:
-  NSEI 8192, BVCI 16386, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 16386, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 2
     NS Transmission error           : 2
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 --- Send message from BSS 1 to SGSN and back, BVCI 3 ---
 
@@ -1511,12 +1511,12 @@ result (UNITDATA) = 4
 
 Gbproxy global:
 Peers:
-  NSEI 8192, BVCI 16386, not blocked, RAC 112-332-16464-96
-  NSEI 8192, BVCI 12290, not blocked, RAC 112-332-16464-96
-  NSEI 4096, BVCI 8194, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 16386, not blocked, RAI 112-332-16464-96
+  NSEI 8192, BVCI 12290, not blocked, RAI 112-332-16464-96
+  NSEI 4096, BVCI 8194, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 2
     NS Transmission error           : 2
-  NSEI 8192, BVCI 4098, not blocked, RAC 112-332-16464-96
+  NSEI 8192, BVCI 4098, not blocked, RAI 112-332-16464-96
     NSEI mismatch                   : 1
 ===== GbProxy test END
 